unit frmPreferences;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, ComCtrls, Menus, Buttons, ORCtrls,
  VA508AccessibilityManager, ActnPopup, Vcl.PlatformDefaultStyleActnCtrls;

const
      ManDemofld : array[0..4] of String = ('cb_Name', 'cb_Location', 'cb_Room',  'cb_Age', 'cb_Sex');

      PatDemo: array[0..8] of String = ('cb_dg_Team',   'cb_dg_FullSSN',
                                        'cb_dg_L4SSN',  'cb_dg_AttendingPhysician',
                                        'cb_dg_DOB',    'cb_dg_PCP', 'cb_dg_Admdate',
                                        'cb_dg_DAYADM', 'cb_dg_AdmDx');
      TempBoxSizes : array[0..3] of integer = ( 453, 225, 146, 102);

      TempText : array[0..3] of String =('TEMP_FLD_1_TITLE', 'TEMP_FLD_2_TITLE', 'TEMP_FLD_3_TITLE','TEMP_FLD_4_TITLE');


type
 //ZZZZZZZZZZZ - added to revert page colors
 TTabSheet = class(ComCtrls.TTabSheet)
  private
    FColor: TColor;
    procedure WMEraseBkGnd(var Msg: TWMEraseBkGnd); message WM_ERASEBKGND;
  public
    constructor Create(aOwner: TComponent); override;
  end;

 TParameters = record
  TEMP_FLD_1_TITLE     : String;
  TEMP_FLD_1_SIZE      : String;
  TEMP_FLD_2_TITLE     : String;
  TEMP_FLD_2_SIZE      : String;
  TEMP_FLD_3_TITLE     : String;
  TEMP_FLD_3_SIZE      : String;
  TEMP_FLD_4_TITLE     : String;
  TEMP_FLD_4_SIZE      : String;
  TEMP_FLD_EXPIRE      : Integer;
  TEMP_FLD_COLOR       : String;
  TEMP_FLD_FONTCOLOR   : String;
  STUDENT              : TStrings;
  RESIDENT             : TStrings;
  DNR_Titles           : TStrings;
  DNR_Text             : TStrings;
  DNR_DIV              : String;
  PATIENT_DEMOGRAPHICS : String;
  PATIENT_DEMO_PRINTLBL : integer;
  MED_DETAIL_FLG       : Integer;
  MED_EXCLUDE_IV       : Integer;
  CONSULTS             : Integer;
  LABS_IMAGING         : Integer;
  PRINT_ORIENTATION    : String;
  ORDER_BY             : Integer;
  MULTI_DNR            : Integer;
  FILE_Location        : String;
end ;

type
  Tfrm_Preference = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    PageControl1: TPageControl;
    TabPatDemo: TTabSheet;
    TabDataObj: TTabSheet;
    TabTempFld: TTabSheet;
    TabContact: TTabSheet;
    TabDNR: TTabSheet;
    pnlDemo: TPanel;
    pnlDemoCol1: TORAutoPanel;
    cb_Name: TORCheckBox;
    cb_Age: TORCheckBox;
    cb_Sex: TORCheckBox;
    cb_Location: TORCheckBox;
    pnlDemoCol2: TORAutoPanel;
    cb_dg_FullSSN: TORCheckBox;
    cb_dg_L4SSN: TORCheckBox;
    cb_dg_DOB: TORCheckBox;
    pnlDemoCol3: TORAutoPanel;
    cb_dg_Team: TORCheckBox;
    cb_dg_AttendingPhysician: TORCheckBox;
    cb_dg_PCP: TORCheckBox;
    pnlDemoCol4: TORAutoPanel;
    cb_dg_Admdate: TORCheckBox;
    cb_dg_DAYADM: TORCheckBox;
    cb_dg_AdmDx: TORCheckBox;
    pnlDataObj: TORAutoPanel;
    cb_do_Consults: TCheckBox;
    cb_do_Labs_Imaging: TCheckBox;
    cbMedExcludeIVs: TCheckBox;
    cbMULTI_DNR: TCheckBox;
    cbMedSummary: TCheckBox;
    cbMedDetails: TCheckBox;
    pnlTempEdtSz: TORAutoPanel;
    pnlTempSz: TORAutoPanel;
    lblBlk3: TOROffsetLabel;
    lblBlk4: TOROffsetLabel;
    lblBlk2: TOROffsetLabel;
    cboBoxSize: TRadioGroup;
    edt_TEMP_FLD_1_SIZE: TORAlignEdit;
    edt_TEMP_FLD_2_SIZE: TORAlignEdit;
    edt_TEMP_FLD_3_SIZE: TORAlignEdit;
    edt_TEMP_FLD_4_SIZE: TORAlignEdit;
    pnlTempEdt: TPanel;
    lbl_Temp1: TOROffsetLabel;
    pnlTempColor: TPanel;
    btnBxColor: TORAlignSpeedButton;
    btnFontColor: TORAlignSpeedButton;
    lblTempExpire: TOROffsetLabel;
    edtFontColor: TORAlignEdit;
    btnSelectFont: TORAlignButton;
    ORAutoPanel1: TORAutoPanel;
    lblExpire: TOROffsetLabel;
    edt_TEMP_FLD_EXPIRE: TEdit;
    UpDown3: TUpDown;
    pnlContact: TORAutoPanel;
    lbl_Resident: TLabel;
    lbl_Student: TLabel;
    lbx_Resident: TORListBox;
    lbx_Student: TORListBox;
    edt_Resident: TORAlignEdit;
    edt_Student: TORAlignEdit;
    pnlDNR: TPanel;
    cboDNR: TORComboBox;
    lbx_DNR_Titles: TORListBox;
    pnlDNRAddRemove: TPanel;
    btnAdd: TORAlignButton;
    btnRemove: TORAlignButton;
    pnlDNRText: TPanel;
    lblDivision: TLabel;
    lbx_DNR_Text: TORListBox;
    edt_DNR_Text: TORAlignEdit;
    Button1: TORAlignButton;
    TabPrintOption: TTabSheet;
    pnlPrint: TORAutoPanel;
    rgOrderby: TRadioGroup;
    rgPrint: TRadioGroup;
    MainMenu1: TMainMenu;
    SelectTeam1: TMenuItem;
    ChangePreference1: TMenuItem;
    SaveSettings1: TMenuItem;
    Exit1: TMenuItem;
    ClearParameters1: TMenuItem;
    DeletePreference1: TMenuItem;
    ColorD: TColorDialog;
    VA508AccessibilityManager1: TVA508AccessibilityManager;
    Splitter1: TSplitter;
    Splitter2: TSplitter;
    Splitter3: TSplitter;
    edt_TEMP_FLD_4_TITLE: TORAlignEdit;
    lbl_Temp4: TOROffsetLabel;
    edt_TEMP_FLD_3_TITLE: TORAlignEdit;
    lbl_Temp3: TOROffsetLabel;
    edt_TEMP_FLD_2_TITLE: TORAlignEdit;
    lbl_Temp2: TOROffsetLabel;
    edt_TEMP_FLD_1_TITLE: TORAlignEdit;
    Panel3: TPanel;
    lbl_DNR_Titles: TLabel;
    Label1: TLabel;
    TabSheet1: TTabSheet;
    edtFilePath: TEdit;
    Label3: TLabel;
    cb_Room: TORCheckBox;
    cbPrintPatDemoLbl: TCheckBox;
    popStudent: TPopupActionBar;
    mnuStuDelete: TMenuItem;
    popResident: TPopupActionBar;
    mnuResDelete: TMenuItem;
    procedure cbPrintPatDemoLblClick(Sender: TObject);
    procedure edtFilePathExit(Sender: TObject);
    procedure TabDataObjResize(Sender: TObject);
    procedure TabPatDemoResize(Sender: TObject);
    procedure TabDNRResize(Sender: TObject);
    procedure TabTempFldResize(Sender: TObject);
    procedure cboBoxSizeClick(Sender: TObject);
    procedure cbMedExcludeIVsClick(Sender: TObject);
    procedure cbMedDetailsClick(Sender: TObject);
    procedure cbMedSummaryClick(Sender: TObject);
    procedure cbMedExcludeIVsKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure cb_dg_DOBKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure cb_do_ConsultsClick(Sender: TObject);
    procedure cb_do_Labs_ImagingClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure cb_dg_FullSSNClick(Sender: TObject);
    procedure cb_dg_L4SSNClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure edt_StudentExit(Sender: TObject);
    procedure edt_StudentKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure lbx_StudentDblClick(Sender: TObject);
    procedure lbx_StudentClick(Sender: TObject);
    procedure edt_ResidentKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure edt_ResidentExit(Sender: TObject);
    procedure lbx_ResidentClick(Sender: TObject);
    procedure lbx_ResidentDblClick(Sender: TObject);
    procedure edt_DNR_TextExit(Sender: TObject);
    procedure edt_DNR_TextKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure lbx_DNR_TitlesDblClick(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure rgOrderbyClick(Sender: TObject);
    procedure cbMULTI_DNRClick(Sender: TObject);
    procedure edt_TEMP_FLD_1_SIZEClick(Sender: TObject);
    procedure lblDivisionClick(Sender: TObject);
    procedure ChangePreference1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure cboDNRNeedData(Sender: TObject; const StartFrom: String;
      Direction, InsertAt: Integer);
    procedure cboDNRDblClick(Sender: TObject);
    procedure Delete1Click(Sender: TObject);
    procedure DeletePreference1Click(Sender: TObject);
    procedure lbx_DNR_TextClick(Sender: TObject);
    procedure lbx_DNR_TextDblClick(Sender: TObject);
    procedure btnBxColorClick(Sender: TObject);
    procedure btnFontColorClick(Sender: TObject);
    procedure btnAddClick(Sender: TObject);
    procedure btnRemoveClick(Sender: TObject);
    procedure btnSelectFontClick(Sender: TObject);
    procedure popResidentPopup(Sender: TObject);
    procedure popStudentPopup(Sender: TObject);
    procedure TabTempFldShow(Sender: TObject);
    procedure TabTempFldHide(Sender: TObject);
    procedure PageControl1DrawTab(Control: TCustomTabControl; TabIndex: Integer;
      const Rect: TRect; Active: Boolean);
  private
    { Private declarations }
    PLevel : String;
    MStudentChg : Boolean;
    ResidentChg : Boolean;
    DNRChg : Boolean;
    SIZEChg : TEdit;
    procedure ReSizeTempBox;
    procedure InitializeParameters;
    procedure InitializeFields;
    procedure AdjFldFontChg;
  public
    { Public declarations }
    VistaPar : TParameters;
    PrefList : TStrings;
    procedure SubmitData(RPC,LEV,PNAME, VALUE : String; LB : TStrings);
  end;

var
  frm_Preference: Tfrm_Preference;

procedure Preferences;

implementation
{$R *.DFM}

uses Orfn, OrNet, frmMain, frmSelectLevel, frmAList, Util;


Procedure Preferences;
var
fPreference : Tfrm_Preference ;
frmPLevel  : TfrmPLevel;
str : string;
begin
  frmPLevel := TfrmPLevel.Create(Application);
  str := SelectParLevel;
  if str <> '' then begin
    fPreference := Tfrm_Preference.Create(Application);
    try
      fPreference.Font := frmListSelect.Font;
      fPreference.PLevel := str;
      fPreference.InitializeParameters;
      fPreference.Caption := fPreference.Caption + ' for ' + piece(fPreference.PLevel,'^',2);
      fPreference.ShowModal;
    finally
     frmPLevel.Free;
     fPreference.Free;
    end;
  end;
end;

procedure Tfrm_Preference.cb_do_ConsultsClick(Sender: TObject);
begin
if cb_do_Consults.Checked then  VistaPar.Consults := 1
else VistaPar.Consults := 0;
end;

procedure Tfrm_Preference.cb_do_Labs_ImagingClick(Sender: TObject);
begin
if cb_do_Labs_Imaging.Checked then  VistaPar.Labs_Imaging := 1
else VistaPar.Labs_Imaging := 0;
end;

procedure Tfrm_Preference.Button1Click(Sender: TObject);
var
   i, sidx, n: integer;
    Component: TComponent;
    Comp, comp2 : TComponent;
    str : String;
    flg : Boolean;
    tList : TStrings;
    vList : TStrings;
begin
  tList := TStringList.Create;
  vList := TStringList.Create;
  tList.Clear;
  vList.Clear;
  ReSizeTempBox;
  case rgPrint.ItemIndex  of
   0 : VistaPar.PRINT_ORIENTATION := 'P';
   1 : VistaPar.PRINT_ORIENTATION := 'L';
  end;


with VistaPar do
  begin
     str := '2,6,7,8,12,';
     for i := 0 to  High(PatDemo) do
        begin
          Component := FindComponent(PatDemo[i]);
           if Component <> nil then
            If (Component as TORCheckbox).Checked then str := str + IntToStr((Component as TORCheckbox).tag) + ',';
        end;
       if pos(',3',str)=0 then
       if pos(',5',str)=0 then str := str + ',5';
    tList.Add('PATIENT_DEMOGRAPHICS' + ':' + str);
    str :='';

     for i := 0 to  High(TempText) do
        begin
          Component := FindComponent('edt_' + TempText[i]);
           if Component <> nil then
               begin
                  tList.Add( TempText[i] + ':' + TEdit(Component).Text);
                  str := TEdit(Component).Text;
               n := i;
               flg := True;
               if (str = '') and (n< High(TempText)) then
                   while flg do
                   begin
                     comp := FindComponent('edt_' + TempText[n+1]);
                     if (comp <> nil) and ((TEdit(Comp).Text)= '') then
                       begin
                        inc(n);
                        if n >High(TempText)-1 then flg := False;
                       end
                     else
                      if comp <> nil then
                        begin
                        flg := False;
                        tList.Add( TempText[n] + ':' + TEdit(Comp).Text);
                        sidx := tList.IndexOf(TempText[n+1] + ':' + (comp as TEdit).Text);
                        if sidx > -1 then tList.Delete(sidx);
                        TEdit(Comp).Text :='';
                           comp2 := FindComponent('edt_TEMP_FLD_' + piece(TempText[n+1],'_',3) + '_SIZE');
                           if comp2 <> nil then
                          begin
                           tList.Add('edt_TEMP_FLD_' + piece(TempText[n],'_',3) + '_SIZE'  + ':' + (comp2 as TEdit).Text);
                           sidx := tList.IndexOf(piece(TempText[n+1],'_',3) + '_SIZE' + ':' + (comp2 as TEdit).Text);
                           if sidx > -1 then tList.Delete(sidx);
                           (comp2 as TEdit).Text :='';
                          end;
                    end;  //while

                 end;

              end;
         end;

         VistaPar.FILE_Location := edtFilePath.Text;

         tList.Add('PATIENT_DEMO_PRINTLBL' + ':' +  IntToStr(VistaPar.PATIENT_DEMO_PRINTLBL));
         tList.Add('MED_DETAIL_FLG' + ':' +  IntToStr(VistaPar.MED_DETAIL_FLG));   //IntToStr(rgMedDetails.ItemIndex));
         tList.Add('PRINT_ORIENTATION' + ':' + VistaPar.PRINT_ORIENTATION);
         tList.Add('CONSULTS' + ':' + IntToStr(VistaPar.CONSULTS));
         tList.Add('LABS_IMAGING' + ':' + IntToStr(VistaPar.LABS_IMAGING));
         tList.Add('MED_EXCLUDE_IV' + ':' + IntToStr(VistaPar.MED_EXCLUDE_IV));
         tList.Add('ORDER_BY' + ':' + IntToStr(VistaPar.ORDER_BY));
         tList.Add('MULTI_DNR' + ':' + IntToStr(VistaPar.MULTI_DNR));
         tList.Add('TEMP_FLD_COLOR' + ':' + VistaPar.TEMP_FLD_COLOR);
         tList.Add('TEMP_FLD_FONTCOLOR' + ':' + VistaPar.TEMP_FLD_FONTCOLOR);
         tList.Add('FILE_Location' + ':' + VistaPar.FILE_Location);


         if pos('^DIV',PLevel)>0 then
         begin
         vList.Add(edt_TEMP_FLD_EXPIRE.TEXT);
         SubmitData('CRHD SAVE XPAR PARAMETERS', PLevel,'CRHD TEMP FLD EXPIRE','',vList )
         end;

          if MStudentChg then
             begin
                STUDENT.Clear;
                STUDENT.AddStrings(lbx_Student.Items);
                SubmitData('CRHD SAVE PARAMETERS', PLevel, 'STUDENT', '',STUDENT);
             end;

            if ResidentChg then
              begin
                RESIDENT.Clear;
                RESIDENT.AddStrings(lbx_Resident.Items);
                SubmitData('CRHD SAVE PARAMETERS', PLevel, 'RESIDENT', '',RESIDENT);
              end;


            if DNRChg then
              begin
                DNR_Titles.Clear;
                DNR_Titles.AddStrings(lbx_DNR_Titles.Items);

                if pos('^DIV',PLevel)>0 then
                  SubmitData('CRHD SAVE XPAR PARAMETERS', PLevel,'CRHD DNR ORDERABLE ITEMS','', lbx_DNR_Titles.Items);

                DNR_Text.Clear;
                DNR_Text.AddStrings(lbx_DNR_Text.Items);

                if pos('^DIV',PLevel)>0 then
                  SubmitData('CRHD SAVE XPAR PARAMETERS', PLevel,'CRHD DNR ORDER TITLE','', lbx_DNR_Text.Items);
               end;
  end;


SubmitData('CRHD SAVE PARAMETERS', PLevel, '','',tList);

tList.clear;
VistaPar.STUDENT.Clear;
VistaPar.RESIDENT.Clear;

tCallV(tList,'CRHD ALL USER PARAMETERS',[frmListSelect.DUZ, piece(frmListSelect.vDiv,'^',1), PLevel]);
frmListSelect.SetParameters(tList);


tList.Clear;
frmListSelect.UserPar.DNR_Titles.Clear;
tCallV(tList, 'CRHD GET XPAR VALUES',[piece(frmListSelect.vDiv,'^',1)+ '^^DIV', 'CRHD DNR ORDER TITLE']);
if tList.Count >0 then frmListSelect.UserPar.DNR_Titles.AddStrings(tList);

lbx_Student.Clear;
lbx_Resident.Clear;
lbx_DNR_Titles.Clear;
lbx_DNR_Text.Clear;
lbx_DNR_Titles.Clear;

frmListSelect.EnableChgPreferenceMenu;

Close;
end;


procedure Tfrm_Preference.cb_dg_DOBKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
if Key = VK_RETURN then (Sender as TORCheckBox).Checked :=  Not (Sender as TORCheckBox).Checked;
end;

procedure Tfrm_Preference.cb_dg_FullSSNClick(Sender: TObject);
begin
cb_dg_L4SSN.Checked := not cb_dg_fullSSN.Checked;
end;

procedure Tfrm_Preference.cb_dg_L4SSNClick(Sender: TObject);
begin
cb_dg_fullSSN.Checked := not cb_dg_L4SSN.Checked;
end;

procedure Tfrm_Preference.FormActivate(Sender: TObject);
begin
InitializeFields;
end;

procedure Tfrm_Preference.InitializeFields;
var
 i : integer;
 Component: TComponent;

begin

        for i := 0 to  High(PatDemo) do
        begin
          Component := FindComponent(PatDemo[i]);
           if Component <> nil then
             If pos(',' + IntToStr((Component as TORCheckbox).tag) + ',' ,VistaPar.PATIENT_DEMOGRAPHICS)>0 then
              (Component as TORCheckbox).Checked := True;
        end;

  edt_TEMP_FLD_1_TITLE.Text := VistaPar.TEMP_FLD_1_TITLE;
  edt_TEMP_FLD_1_SIZE.Text := VistaPar.TEMP_FLD_1_SIZE;

  edt_TEMP_FLD_2_TITLE.Text := VistaPar.TEMP_FLD_2_TITLE;
  edt_TEMP_FLD_2_SIZE.Text := VistaPar.TEMP_FLD_2_SIZE;

  edt_TEMP_FLD_3_TITLE.Text :=  VistaPar.TEMP_FLD_3_TITLE;
  edt_TEMP_FLD_3_SIZE.Text := VistaPar.TEMP_FLD_3_SIZE;

  edt_TEMP_FLD_4_TITLE.Text := VistaPar.TEMP_FLD_4_TITLE;
  edt_TEMP_FLD_4_SIZE.Text := VistaPar.TEMP_FLD_4_SIZE;

  edt_TEMP_FLD_EXPIRE.Text := IntToStr(VistaPar.TEMP_FLD_EXPIRE);

  edt_TEMP_FLD_1_TITLE.Color := StrToInt(VistaPar.TEMP_FLD_COLOR);
  edt_TEMP_FLD_2_TITLE.Color := StrToInt(VistaPar.TEMP_FLD_COLOR);
  edt_TEMP_FLD_3_TITLE.Color := StrToInt(VistaPar.TEMP_FLD_COLOR);
  edt_TEMP_FLD_4_TITLE.Color := StrToInt(VistaPar.TEMP_FLD_COLOR);
  edtFontColor.Color := StrToInt(VistaPar.TEMP_FLD_COLOR);

  edt_TEMP_FLD_1_TITLE.Font.Color := StrToInt(VistaPar.TEMP_FLD_FONTCOLOR);
  edt_TEMP_FLD_2_TITLE.Font.Color := StrToInt(VistaPar.TEMP_FLD_FONTCOLOR);
  edt_TEMP_FLD_3_TITLE.Font.Color := StrToInt(VistaPar.TEMP_FLD_FONTCOLOR);
  edt_TEMP_FLD_4_TITLE.Font.Color := StrToInt(VistaPar.TEMP_FLD_FONTCOLOR );

  edtFontColor.Font.Color := StrToInt(VistaPar.TEMP_FLD_FONTCOLOR);
  edtFontColor.ReadOnly := True;

  lbx_Student.Items.Clear;
  lbx_Resident.Items.Clear;
  lbx_DNR_Titles.Items.Clear;
  lbx_DNR_Text.Items.Clear;

  lbx_Student.items.AddStrings(VistaPar.STUDENT);
  lbx_Resident.items.AddStrings(VistaPar.RESIDENT);
  lbx_DNR_Titles.Items.AddStrings(VistaPar.DNR_Titles);
  lbx_DNR_Text.Items.AddStrings(VistaPar.DNR_Text);

  if VistaPar.CONSULTS = 1 then cb_do_Consults.Checked := True
  else  cb_do_Consults.Checked :=  False;

  if VistaPar.LABS_IMAGING = 1 then cb_do_Labs_Imaging.Checked := True
  else  cb_do_Labs_Imaging.Checked :=  False;

  if VistaPar.MED_EXCLUDE_IV = 0 then  cbMedExcludeIVs.checked := True
  else cbMedExcludeIVs.checked := False;

  if VistaPar.MED_DETAIL_FLG = 1 then cbMedDetails.Checked:= True
  else cbMedSummary.Checked := True;


  if VistaPar.PRINT_ORIENTATION = 'P' then rgPrint.itemIndex := 0
  else rgPrint.ItemIndex := 1;

  rgOrderby.ItemIndex := VistaPar.ORDER_BY;

   if VistaPar.MULTI_DNR = 1 then cbMULTI_DNR.Checked := True
   else cbMULTI_DNR.Checked := False;

  if VistaPar.PATIENT_DEMO_PRINTLBL = 1 then cbPrintPatDemoLbl.Checked := True
   else cbPrintPatDemoLbl.Checked := False;

  edtFilePath.Text := VistaPar.FILE_Location;

  if pos('^DIV',PLevel)=0 then
    begin
     Component := PageControl1.FindChildControl('TabDNR');
     if Component <> nil then
     begin
      (Component as TTabSheet).Enabled := False;
       lblExpire.Enabled := False;
       edt_TEMP_FLD_EXPIRE.Enabled := False;
       UpDown3.Enabled := False;
     end;
    end
    else
    begin
     Component := PageControl1.FindChildControl('TabDNR');
     if Component <> nil then (Component as TTabSheet).Enabled := True;
     lblExpire.Enabled := True;
     edt_TEMP_FLD_EXPIRE.Enabled := True;
     UpDown3.Enabled := True;
    end;
end;

procedure Tfrm_Preference.edt_StudentExit(Sender: TObject);
begin
  If edt_Student.Text <> '' then
    begin
      if lbx_Student.Items.IndexOf(edt_Student.Text)< 0 then
       begin
         if edt_Student.Text <> '' then
           begin
            lbx_Student.Items.Add(edt_Student.Text);
            edt_Student.Text := '';
            MStudentChg := True;
           end;
       end
       else
        edt_Student.Text := '';
    end;
end;

procedure Tfrm_Preference.edt_StudentKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
If key = VK_RETURN then
  begin
    if lbx_Student.Items.IndexOf(edt_Student.Text)< 0 then
      begin
        if edt_Student.Text <> '' then
        begin
         lbx_Student.Items.Add(edt_Student.Text);
         edt_Student.Text := '';
         MStudentChg := True;
        end;
      end;
  end;
end;

procedure Tfrm_Preference.lbx_StudentDblClick(Sender: TObject);
begin
 if lbx_Student.Items[lbx_Student.ItemIndex] = edt_Student.Text then edt_Student.Text := '';
 if MessageDlg('Are you sure you want to delete this entry?',
    mtConfirmation, [mbYes, mbNo], 0) = mrYes then
    begin
     lbx_Student.Items.Delete(lbx_Student.ItemIndex);
     MStudentChg := True;
    end;
end;

procedure Tfrm_Preference.popResidentPopup(Sender: TObject);
begin
  mnuResDelete.Enabled := lbx_Resident.ItemIndex > -1;
end;

procedure Tfrm_Preference.popStudentPopup(Sender: TObject);
begin
  mnuStuDelete.Enabled := lbx_Student.ItemIndex > -1;
end;

procedure Tfrm_Preference.lbx_StudentClick(Sender: TObject);
begin
edt_Student.Text := lbx_Student.Items[lbx_Student.itemindex];
end;

procedure Tfrm_Preference.edt_ResidentKeyDown(Sender: TObject;
  var Key: Word; Shift: TShiftState);
begin
If key = VK_RETURN then
  begin
    if lbx_Resident.Items.IndexOf(edt_Resident.Text)< 0 then
      begin
       if edt_Resident.Text <> '' then
         begin
           lbx_Resident.Items.Add(edt_Resident.Text);
           edt_Resident.Text := '';
           ResidentChg := True;
         end;
      end;
  end;
end;

procedure Tfrm_Preference.edt_ResidentExit(Sender: TObject);
begin
  If edt_Resident.Text <> '' then
    begin
      if lbx_Resident.Items.IndexOf(edt_Resident.Text)< 0 then
       begin
         if edt_Resident.Text <> '' then
           begin
             lbx_Resident.Items.Add(edt_Resident.Text);
             edt_Resident.Text := '';
             ResidentChg := True;
           end;
       end
       else
        edt_Resident.Text := '';
    end;
end;

procedure Tfrm_Preference.lbx_ResidentClick(Sender: TObject);
begin
edt_Resident.Text := lbx_Resident.Items[lbx_Resident.itemindex];
end;

procedure Tfrm_Preference.lbx_ResidentDblClick(Sender: TObject);
begin
  if lbx_Resident.Items[lbx_Resident.ItemIndex] = edt_Resident.Text then edt_Resident.Text := '';
 if MessageDlg('Are you sure you want to delete this entry?',
    mtConfirmation, [mbYes, mbNo], 0) = mrYes then
    begin
     lbx_Resident.Items.Delete(lbx_Resident.ItemIndex);
     ResidentChg := True;
    end;

end;

procedure Tfrm_Preference.edtFilePathExit(Sender: TObject);
var
tdir : String;
begin
tdir :=  ExtractFilePath(edtFilePath.Text);
if not (tdir = edtFilePath.Text) then
 begin
  Showmessage('Only file path needed,' + tdir + ' used');
  edtFilePath.Text := tdir;
 end;

end;

procedure Tfrm_Preference.edt_DNR_TextExit(Sender: TObject);
begin
  If edt_DNR_Text.Text <> '' then
    begin
      if lbx_DNR_Text.Items.IndexOf(edt_DNR_Text.Text)< 0 then
       begin
         lbx_DNR_Text.Items.Add(edt_DNR_Text.Text);
         edt_DNR_Text.Text := '';
         DNRChg := True;
       end
       else
        edt_DNR_Text.Text := '';
    end;
end;

procedure Tfrm_Preference.edt_DNR_TextKeyDown(Sender: TObject;
  var Key: Word; Shift: TShiftState);
var
s,id  : integer;

begin
if key = VK_RETURN then
  begin
   id := lbx_DNR_Text.Items.IndexOf(edt_DNR_Text.Text);
    if id < 0 then
      begin
       lbx_DNR_Text.Items.Add(edt_DNR_Text.Text);
       edt_DNR_Text.Text := '';
       DNRChg := True;
      end
      else
        begin
         s := compareStr(lbx_DNR_Text.Items[id],edt_DNR_Text.Text);
         if s <> 0 then
           begin
           lbx_DNR_Text.Items.Add(edt_DNR_Text.Text);
            edt_DNR_Text.Text := '';
            DNRChg := True;
           end;
        end;
  end;
end;

procedure Tfrm_Preference.lbx_DNR_TitlesDblClick(Sender: TObject);
begin
if lbx_DNR_Titles.ItemIndex > -1 then
begin
 lbx_DNR_Titles.Items.Delete(lbx_DNR_Titles.ItemIndex);
 DNRChg := True;
end;
end;

procedure Tfrm_Preference.SubmitData(RPC, LEV, PNAME, VALUE: String;
  LB: TStrings);
begin
 CallV(RPC, [LEV, PNAME, VALUE , LB]);
end;

procedure Tfrm_Preference.TabDataObjResize(Sender: TObject);
var
dw : integer;
begin
//Middle section width
dw := TabDataObj.Width;
cbMedSummary.Width := dw;
cbMedDetails.Width := dw;
cbMedExcludeIVs.Width := dw;
cb_do_Consults.Width := dw;
cb_do_Labs_Imaging.Width := dw;
cbMULTI_DNR.Width := dw;
cbPrintPatDemoLbl.Width := dw;
end;

procedure Tfrm_Preference.TabDNRResize(Sender: TObject);
var
h : integer;
begin
case Font.Size of
   8..12 : begin
             pnlDNRAddRemove.Width := 93;
           end;
   18    : begin
             pnlDNRAddRemove.Width := 143;
           end;
   24    : begin
             pnlDNRAddRemove.Width := 166;
           end;
end;


btnAdd.Height  := Trunc(pnlDNRAddRemove.Height/2);

pnlDNRAddRemove.Width := Round(TabDNR.Width * 0.15);
h := Round((TabDNR.Width - pnlDNRAddRemove.Width)/ 3);
lbx_DNR_Titles.Width := h;
cboDNR.Width := h;
Label1.Width := pnlDNRText.Width;
end;

procedure Tfrm_Preference.TabPatDemoResize(Sender: TObject);
var
dw : integer;
begin
//Demographic width
dw := Round(pnlDemo.Width/4);
pnlDemoCol1.Width := dw;
pnlDemoCol2.Width := dw;
pnlDemoCol3.Width := dw;
pnlDemoCol4.Width := dw;
dw :=dw - 5;
cb_Name.Width := dw;
cb_Age.Width := dw;
cb_Sex.Width := dw;
cb_Location.Width := dw;
cb_Room.Width := dw;
cb_dg_FullSSN.Width := dw;
cb_dg_L4SSN.Width := dw;
cb_dg_DOB.Width := dw;
cb_dg_Team.Width := dw;
cb_dg_AttendingPhysician.Width := dw;
cb_dg_PCP.Width := dw;
cb_dg_Admdate.Width := dw;
cb_dg_DAYADM.Width := dw;
cb_dg_AdmDx.Width := dw;
end;

procedure Tfrm_Preference.TabTempFldHide(Sender: TObject);
begin
  VistaPar.TEMP_FLD_EXPIRE := StrToInt(edt_TEMP_FLD_EXPIRE.Text);
end;

procedure Tfrm_Preference.TabTempFldResize(Sender: TObject);
var
h : integer;
begin
h := 32;
edt_TEMP_FLD_1_TITLE.Height := h;
edt_TEMP_FLD_2_TITLE.Height := h;
edt_TEMP_FLD_3_TITLE.Height := h;
edt_TEMP_FLD_4_TITLE.Height := h;

edt_TEMP_FLD_1_SIZE.Height := edt_TEMP_FLD_1_TITLE.Height;
lblBlk2.Height := lbl_Temp2.Height;
edt_TEMP_FLD_2_SIZE.Height := edt_TEMP_FLD_2_TITLE.Height;
lblBlk3.Height := lbl_Temp3.Height;
edt_TEMP_FLD_3_SIZE.Height := edt_TEMP_FLD_3_TITLE.Height;
lblBlk4.Height := lbl_Temp4.Height;
edt_TEMP_FLD_4_SIZE.Height := edt_TEMP_FLD_4_TITLE.Height;


edt_TEMP_FLD_EXPIRE.Top :=lblExpire.Top + lblExpire.Height + 2;
UpDown3.Top := edt_TEMP_FLD_EXPIRE.Top;
UpDown3.Left := edt_TEMP_FLD_EXPIRE.Left + edt_TEMP_FLD_EXPIRE.Width+1;
end;

procedure Tfrm_Preference.TabTempFldShow(Sender: TObject);
begin
  edt_TEMP_FLD_EXPIRE.Text := IntToStr(VistaPar.TEMP_FLD_EXPIRE);
end;

procedure Tfrm_Preference.InitializeParameters;
var
TL  : TStringList;
i   :integer;
str : String;
uDiv : String;
begin
if PLevel = '' then exit;

TL := TStringList.create;
TL.Clear;
if pos('^DIV',PLevel)> 0 then tCallV(TL,'CRHD GET PREFERENCES',[PLevel + '-' + piece(PLevel,'^',1)])
else tCallV(TL,'CRHD GET PREFERENCES',[PLevel + '-' + piece(frmListSelect.vDiv,'^',1)]);

if VistaPar.RESIDENT = nil then VistaPar.RESIDENT := TStringList.Create
else VistaPar.RESIDENT.Clear;
if VistaPar.STUDENT = nil then VistaPar.STUDENT := TStringlist.Create
else VistaPar.STUDENT.Clear;
if VistaPar.DNR_Titles = nil then VistaPar.DNR_Titles := TStringlist.Create
else VistaPar.DNR_Titles.Clear;
if VistaPar.DNR_Text = nil then VistaPar.DNR_Text := TStringlist.Create
else VistaPar.DNR_Text.Clear;

    VistaPar.MED_DETAIL_FLG := 0;
    for i := 0 to TL.count -1 do
      begin
        if  pos('TEMP_FLD_1_TITLE',piece(TL[i],'^',1))>0   then VistaPar.TEMP_FLD_1_TITLE := piece(TL[i],'^',2);
        if  pos('edt_TEMP_FLD_1_SIZE',piece(TL[i],'^',1))>0  then VistaPar.TEMP_FLD_1_SIZE := piece(TL[i],'^',2);
        if  pos('TEMP_FLD_2_TITLE',piece(TL[i],'^',1))>0  then VistaPar.TEMP_FLD_2_TITLE := piece(TL[i],'^',2);
        if  pos('TEMP_FLD_2_SIZE',piece(TL[i],'^',1))>0  then VistaPar.TEMP_FLD_2_SIZE := piece(TL[i],'^',2);
        if  pos('TEMP_FLD_3_TITLE',piece(TL[i],'^',1))>0 then VistaPar.TEMP_FLD_3_TITLE := piece(TL[i],'^',2);
        if  pos('edt_TEMP_FLD_3_SIZE',piece(TL[i],'^',1))>0  then VistaPar.TEMP_FLD_3_SIZE := piece(TL[i],'^',2);
        if  pos('TEMP_FLD_4_TITLE',piece(TL[i],'^',1))>0  then VistaPar.TEMP_FLD_4_TITLE := piece(TL[i],'^',2);
        if  pos('edt_TEMP_FLD_4_SIZE',piece(TL[i],'^',1))>0  then VistaPar.TEMP_FLD_4_SIZE := piece(TL[i],'^',2);
        if  pos('TEMP_FLD_EXPIRE',piece(TL[i],'^',1))>0  then VistaPar.TEMP_FLD_EXPIRE := StrToInt(piece(TL[i],'^',2));
        if  pos('TEMP_FLD_COLOR',piece(TL[i],'^',1))>0   then VistaPar.TEMP_FLD_COLOR := piece(TL[i],'^',2);
        if  pos('TEMP_FLD_FONTCOLOR',piece(TL[i],'^',1))>0   then VistaPar.TEMP_FLD_FONTCOLOR := piece(TL[i],'^',2);
        if  pos('PATIENT_DEMOGRAPHICS',piece(TL[i],'^',1))>0  then VistaPar.PATIENT_DEMOGRAPHICS := piece(TL[i],'^',2);
        if  pos('RESIDENT',piece(TL[i],'^',1))>0  then VistaPar.RESIDENT.Add(piece(TL[i],'^',2));
        if  pos('STUDENT',piece(TL[i],'^',1))>0  then VistaPar.STUDENT.Add(piece(TL[i],'^',2));
        if  pos('CONSULTS',piece(TL[i],'^',1))>0  then VistaPar.CONSULTS := StrToInt(piece(TL[i],'^',2));
        if  pos('LABS_IMAGING',piece(TL[i],'^',1))>0  then VistaPar.LABS_IMAGING := StrToInt(piece(TL[i],'^',2));
        if  pos('DNR_Titles',piece(TL[i],'^',1))>0  then VistaPar.DNR_Titles.Add(piece(TL[i],'^',2) + '^' + piece(TL[i],'^',3));
        if  pos('DNR_Text',piece(TL[i],'^',1))>0  then VistaPar.DNR_Text.Add(piece(TL[i],'^',2) + '^' + piece(TL[i],'^',3));
        if  pos('MED_DETAIL_FLG',piece(TL[i],'^',1))>0  then  VistaPar.MED_DETAIL_FLG :=StrToInt(piece(TL[i],'^',2));
        if  pos('MED_EXCLUDE_IV',piece(TL[i],'^',1))>0  then  VistaPar.MED_EXCLUDE_IV :=StrToInt(piece(TL[i],'^',2));
        if  pos('PRINT_ORIENTATION',piece(TL[i],'^',1))>0  then  VistaPar.PRINT_ORIENTATION :=piece(TL[i],'^',2);
        if  pos('ORDER_BY',piece(TL[i],'^',1))>0  then  VistaPar.ORDER_BY := StrToInt(piece(TL[i],'^',2));
        if  pos('PATIENT_DEMO_PRINTLBL',piece(TL[i],'^',1))>0  then  VistaPar.PATIENT_DEMO_PRINTLBL := StrToInt(piece(TL[i],'^',2));
        if  pos('MULTI_DNR',piece(TL[i],'^',1))>0  then  VistaPar.MULTI_DNR := StrToInt(piece(TL[i],'^',2));
        if  pos('FILE_Location',piece(TL[i],'^',1))>0  then  VistaPar.FILE_Location := piece(TL[i],'^',2);
        if VistaPar.TEMP_FLD_COLOR = '' then VistaPar.TEMP_FLD_COLOR := IntToStr(clYellow);
        if VistaPar.TEMP_FLD_FONTCOLOR = '' then VistaPar.TEMP_FLD_FONTCOLOR := IntToStr(clBlack);

   if pos('^DIV', PLevel)>0  then uDiv := piece(PLevel,'^',1) + ' - ' + piece(PLevel,'^',2)
   else uDiv := piece(frmListSelect.vDiv,'^',1) + ' - '+ piece(frmListSelect.vDiv,'^',2);

   lblDivision.Caption := uDiv;
 end;
end;

procedure Tfrm_Preference.Exit1Click(Sender: TObject);
begin
Close
end;
procedure Tfrm_Preference.FormShow(Sender: TObject);
begin
  MStudentChg := False;
  ResidentChg := False;
  DNRChg := False;
end;

procedure Tfrm_Preference.rgOrderbyClick(Sender: TObject);
begin
VistaPar.ORDER_BY := rgOrderby.ItemIndex;
end;

procedure Tfrm_Preference.cbMedDetailsClick(Sender: TObject);
begin
cbMedSummary.Checked := Not cbMedDetails.Checked ;
if cbMedDetails.Checked then  VistaPar.MED_DETAIL_FLG := 1
else VistaPar.MED_DETAIL_FLG := 0;
end;

procedure Tfrm_Preference.cbMedExcludeIVsClick(Sender: TObject);
begin
if cbMedExcludeIVs.Checked then  VistaPar.MED_EXCLUDE_IV := 0
else VistaPar.MED_EXCLUDE_IV := 1;
end;

procedure Tfrm_Preference.cbMedExcludeIVsKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
if Key = VK_RETURN then (Sender as TCheckBox).Checked :=  Not (Sender as TCheckBox).Checked;
end;

procedure Tfrm_Preference.cbMULTI_DNRClick(Sender: TObject);
begin
if cbMULTI_DNR.Checked then VistaPar.MULTI_DNR := 1
else VistaPar.MULTI_DNR := 0;
end;

procedure Tfrm_Preference.ReSizeTempBox;
begin
end;

procedure Tfrm_Preference.edt_TEMP_FLD_1_SIZEClick(Sender: TObject);
begin
SIZEChg := (Sender as TEdit);
end;

procedure Tfrm_Preference.cboBoxSizeClick(Sender: TObject);
begin
if SIZEChg <> nil then
  begin
    SIZEChg.ReadOnly := False;
    SIZEChg.Text := '';
    if cboBoxsize.ItemIndex > -1 then
    begin
      SIZEChg.Text := cboBoxSize.items[cboBoxsize.ItemIndex];
      SIZEChg.ReadOnly := True;
    end;
  end;
end;

procedure Tfrm_Preference.lblDivisionClick(Sender: TObject);
var
tmpS : String;
begin
tmpS :=GetList('CRHD GET USER DIVISIONS', 2) ;
end;

procedure Tfrm_Preference.ChangePreference1Click(Sender: TObject);
var
pList,vs : String;
begin
pList:=GetList('CRHD AVAILABLE PARAMETERS', 3) ;


if pos(';DIC(4,',pList)>0 then vs := 'DIV';
if pos(';VA(200,',pList)>0 then vs := 'USR';
if pos(';OR(100.21,',pList)>0 then vs := 'OTL';
if pos(';DIC(49,',pList)>0 then vs := 'SRV';
if pos(';DIC(45.7,',pList)>0 then vs := 'TS';
if pos(';SC(,',pList)>0 then vs := 'LOC';

pLevel := piece(piece(pList,'^',2),';',1) + '^' + piece(pList,'^',3) + '^' + vs;

InitializeParameters;
InitializeFields;
end;

procedure Tfrm_Preference.cbMedSummaryClick(Sender: TObject);
begin
cbMedDetails.Checked := Not cbMedSummary.Checked;
if cbMedSummary.Checked then  VistaPar.MED_DETAIL_FLG := 0
else VistaPar.MED_DETAIL_FLG := 1;
end;

procedure Tfrm_Preference.FormCreate(Sender: TObject);
begin
Font := frmListSelect.Font;
AdjFldFontChg;
with cboDNR do
 begin
  ListItemsOnly := true;
  LongList := true;
  InitLongList('A');
 end;
end;

procedure Tfrm_Preference.cboDNRNeedData(Sender: TObject;
  const StartFrom: String; Direction, InsertAt: Integer);
begin
cboDNR.ForDataUse(SubSetOrderableItems(StartFrom, Direction));
end;

procedure Tfrm_Preference.cbPrintPatDemoLblClick(Sender: TObject);
begin
if cbPrintPatDemoLbl.Checked then VistaPar.PATIENT_DEMO_PRINTLBL := 1
else VistaPar.PATIENT_DEMO_PRINTLBL := 0;
end;

procedure Tfrm_Preference.cboDNRDblClick(Sender: TObject);
begin

if cboDNR.ItemIndex > -1 then
if Not findDup(cboDNR.Items[cboDNR.ItemIndex], lbx_DNR_Titles.Items) then
begin
 lbx_DNR_Titles.Items.Add(cboDNR.Items[cboDNR.ItemIndex]);
 DNRChg := True;
 end;
end;

procedure Tfrm_Preference.Delete1Click(Sender: TObject);
var
nidx :integer;
begin
nidx := CurrentIndex( lbx_DNR_Titles.ItemIndex,lbx_DNR_Titles.Items.Count);
if lbx_DNR_Titles.ItemIndex > -1 then
lbx_DNR_Titles.Items.Delete(lbx_DNR_Titles.ItemIndex);

if lbx_DNR_Titles.Items.Count > 0 then lbx_DNR_Titles.ItemIndex := nidx;
end;

procedure Tfrm_Preference.DeletePreference1Click(Sender: TObject);
begin
if MessageDlg('Are you sure you want to DELETE this Preference?',
    mtConfirmation, [mbYes, mbNo], 0) = mrYes then
     begin
      CALLV('CRHD DELETE A PREFERENCE',[PLevel]);
      if piece(Plevel,'^',1)= piece(piece(frmListSelect.Pref,'^',2),';',1) then frmListSelect.UpdateMyPref;

      frmListSelect.EnableChgPreferenceMenu;

      close;
    end;
end;
procedure Tfrm_Preference.lbx_DNR_TextClick(Sender: TObject);
begin
edt_DNR_Text.Text := lbx_DNR_Text.Items[lbx_DNR_Text.itemindex];
end;

procedure Tfrm_Preference.lbx_DNR_TextDblClick(Sender: TObject);
begin
 if lbx_DNR_Text.Items[lbx_DNR_Text.ItemIndex] = edt_DNR_Text.Text then edt_DNR_Text.Text := '';
 lbx_DNR_Text.Items.Delete(lbx_DNR_Text.ItemIndex);
 DNRChg := True;
end;

procedure Tfrm_Preference.btnBxColorClick(Sender: TObject);
begin
 if ColorD.Execute then
 begin
    edtFontColor.Color := ColorD.Color;
    edtFontColor.Repaint;
 end;
end;

procedure Tfrm_Preference.btnFontColorClick(Sender: TObject);
begin
 if ColorD.Execute then
  begin
    edtFontColor.Enabled := True;
    edtFontColor.Font.Color := ColorD.Color;
    edtFontColor.Repaint;
  end;
end;

procedure Tfrm_Preference.btnAddClick(Sender: TObject);
begin
cboDNRDblClick(cboDNR);
end;

procedure Tfrm_Preference.btnRemoveClick(Sender: TObject);
begin
lbx_DNR_TitlesDblClick(lbx_DNR_Titles);
end;

procedure Tfrm_Preference.btnSelectFontClick(Sender: TObject);
begin
   edt_TEMP_FLD_1_TITLE.Color := edtFontColor.Color;
   edt_TEMP_FLD_2_TITLE.Color := edtFontColor.Color;
   edt_TEMP_FLD_3_TITLE.Color := edtFontColor.Color;
   edt_TEMP_FLD_4_TITLE.Color := edtFontColor.Color;

   edt_TEMP_FLD_1_TITLE.Font.Color := edtFontColor.Font.Color;
   edt_TEMP_FLD_2_TITLE.Font.Color := edtFontColor.Font.Color;
   edt_TEMP_FLD_3_TITLE.Font.Color := edtFontColor.Font.Color;
   edt_TEMP_FLD_4_TITLE.Font.Color := edtFontColor.Font.Color;

   edt_TEMP_FLD_1_TITLE.Repaint;
   edt_TEMP_FLD_2_TITLE.Repaint;
   edt_TEMP_FLD_3_TITLE.Repaint;
   edt_TEMP_FLD_4_TITLE.Repaint;

   VistaPar.TEMP_FLD_COLOR := IntToStr(edtFontColor.Color);
   VistaPar.TEMP_FLD_FONTCOLOR := IntToStr(edtFontColor.Font.Color);
end;

procedure Tfrm_Preference.AdjFldFontChg;
const

  TAB_VOFFSET = 7;
var
  OldFont: TFont;
  NewFontSize : integer;
begin
  NewFontSize := Font.Size;
  OldFont := TFont.Create;
  try
    DisableAlign;
    try
      OldFont.Assign(Font);
      with Self do Font.Size := NewFontSize;

      case NewFontSize of
         8 : Font.Height := -11;
         10 : Font.Height := -13;
         12 : Font.Height := -16;
         18 : Font.Height := -24;
         24 : Font.Height := -32;
      end;

    finally
      EnableAlign;
    end;
  finally
    OldFont.Free;
  end;
end;

//ZZZZZZBELLC - added to revert page colors
procedure Tfrm_Preference.PageControl1DrawTab(Control: TCustomTabControl;
  TabIndex: Integer; const Rect: TRect; Active: Boolean);
var
  AText: string;
  APoint: TPoint;
begin
  with (Control as TPageControl).Canvas do
  begin
    FillRect(Rect);
    AText := TPageControl(Control).Pages[TabIndex].Caption;
    with Control.Canvas do
    begin
      APoint.x := (Rect.Right - Rect.Left) div 2 - TextWidth(AText) div 2;
      APoint.y := (Rect.Bottom - Rect.Top) div 2 - TextHeight(AText) div 2;
      TextRect(Rect, Rect.Left + APoint.x, Rect.Top + APoint.y, AText);
    end;
  end;
end;

//----------------- TTabSheet -----------------//
constructor TTabSheet.Create(aOwner: TComponent);
begin
  inherited;
  FColor := clBtnFace;
end;

procedure TTabSheet.WMEraseBkGnd(var Msg: TWMEraseBkGnd);
begin
    Brush.Color := FColor;
    Windows.FillRect(Msg.dc, ClientRect, Brush.Handle);
    Msg.Result := 1;
end;



end.
