unit frmTeamRoster;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, ComCtrls, ORCtrls, jpeg, Menus, VA508AccessibilityManager;

type
  TfrmTeamRoster = class(TForm)
    pnlMain: TPanel;
    pnlTop: TPanel;
    cboPList: TORComboBox;
    pnlRtSelect: TPanel;
    pnlBottom: TPanel;
    ListView1: TListView;
    pnlTmNotes: TPanel;
    mmTmNotes: TRichEdit;
    imgPh: TImage;
    btnTeam: TORAlignButton;
    btnUser: TORAlignButton;
    btnSpecialty: TORAlignButton;
    btnHOTeam: TORAlignButton;
    btnService: TORAlignButton;
    PopupMenu1: TPopupMenu;
    Print1: TMenuItem;
    Save1: TMenuItem;
    VA508AccessibilityManager1: TVA508AccessibilityManager;
    procedure btnUserKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure btnTeamKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure btnServiceKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure btnHOTeamKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure btnSpecialtyKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormShow(Sender: TObject);
    procedure lbl_TeamClick(Sender: TObject);
    procedure lbl_UserClick(Sender: TObject);
    procedure cboPListNeedData(Sender: TObject; const StartFrom: String;
      Direction, InsertAt: Integer);
    procedure cboPListDblClick(Sender: TObject);
    procedure cboPListKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure lbl_ServiceClick(Sender: TObject);
    procedure lbl_SpecialtyClick(Sender: TObject);
    procedure lbl_HOTeamClick(Sender: TObject);
    procedure Print1Click(Sender: TObject);
    procedure Save1Click(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure ListView1CustomDrawItem(Sender: TCustomListView;
      Item: TListItem; State: TCustomDrawState; var DefaultDraw: Boolean);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
    Obj : TObject;
    Team : String;
    TeamMgr : String;
    LMemo : TORListbox;
    NewRow : Boolean;
    FileOpened : String;

    procedure NewMemoSetup(NewMM: TORListbox; NewLBL : TLabel);
    procedure AddListViewItem(const aValue: String; FieldNames: array of Shortstring; aLV: TListView);
    procedure AddColumnsToListView(FieldNames: array of Shortstring; aLV: TListView);
    procedure CanEditTextDoc(TM: String);
    procedure TurnToBlack;
  public
    { Public declarations }
    NewMemo: TORListBox;
    NewLabel: TLabel;
    ListCtrls : TStrings;
    function FindAComponent(name : String): TComponent;
    procedure SetTeamSection(FList : TStrings);
  end;


procedure TeamPhoneNumbers(TM : String);

implementation

{$R *.DFM}

uses frmMain, ORNet, ORfn, rCore, frmSelectLevel, Util;

const
  FieldNames: array[0..9] of ShortString = ('NAME','TITLE','OFFICE PHONE','PAGER','ROOM #','EMAIL','FAX','SERVICE','MAIL CODE','SITE');
  ZVA_PH : array[0..6] of ShortString = ('NAME','TITLE','EXT','PAGER','ROOM','SECTION','FAX');
  ZVA_OTH : array[0..5] of ShortString = ('NAME','EXT','PAGER','ROOM','SECTION','FAX');
  ZVA_SRV : array[0..6] of ShortString = ('NAME','PHONE','DIVISION','FAX','MC','ROOM','CHIEF');


Procedure TeamPhoneNumbers(TM : String);
var
frmTeamRoster : TfrmTeamRoster ;
begin
  frmTeamRoster := TfrmTeamRoster.Create(frmListSelect);
  try
    if TM = '' then TM := frmListSelect.DUZ + '^USR';
    frmTeamRoster.ShowModal;
  finally
    frmTeamRoster.Free;
  end;
end;

// TeamRoster start here
function TfrmTeamRoster.FindAComponent(name: String): TComponent;
begin
Result := FindComponent(name);
end;

procedure TfrmTeamRoster.FormShow(Sender: TObject);
var
rList : TStrings;
begin
  rList := TStringList.Create;

  if Team = '' then Team := frmListSelect.DUZ + '^USR';

  rList.Clear;

  tCallV(rList,'CRHD GET TEAM PHONE NUMBERS',[Team]);

  if rList.count = 0 then lbl_TeamClick(btnTeam);

  if cboPList.itemIndex > -1 then cboPList.SetFocus;
  ListView1.Columns.Clear;
  ListView1.Items.Clear;
end;

procedure TfrmTeamRoster.NewMemoSetup(NewMM: TORListbox; NewLBL : TLabel);
begin     //1
  with NewMM do
    begin    //2
      Height := 90;
      ShowHint := False;
      if LMemo <> nil then
        begin   //3
         Top := LMemo.Top;
         if (not NewRow) then
           begin     //4
            Left := LMemo.Left + LMemo.Width + 3;
            NewLBL.Left := NewMM.Left;
            NewLBL.Top := LMemo.Top - 15;
            LMemo := NewMM;
           end      //4
         else
           begin    //5
             NewLBL.Left := NewMemo.Left;
             NewLBL.Top := NewMemo.Top -15;
             NewRow := False;
             LMemo := NewMM;
           end;  //5
        end;  //3
    end;   //2
end;  //1

procedure TfrmTeamRoster.lbl_TeamClick(Sender: TObject);
begin
obj := (Sender as TButton);
TurnToBlack;

cboPList.Visible := True;
cboPList.Items.Clear;
cboPList.Text := '';
ListTeamAll(cboPList.Items);
end;

procedure TfrmTeamRoster.lbl_UserClick(Sender: TObject);
begin
obj := (Sender as TButton);
TurnToBlack;
cboPList.Visible := True;
cboPList.Items.Clear;
cboPList.Text := '';
//populate Provider List
with cboPList do
 begin
  ListItemsOnly := true;
  LongList := true;
  InitLongList('');
 end;
end;

procedure TfrmTeamRoster.cboPListNeedData(Sender: TObject;
  const StartFrom: String; Direction, InsertAt: Integer);
begin
if (obj as TButton).Name = 'btnUser' then cboPList.ForDataUse(SubSetOfPersons(StartFrom, Direction));   // ActiveAndInactive
end;

procedure TfrmTeamRoster.SetTeamSection(FList: TStrings);
var
Component, Component0: TComponent;
str : string;
frmTeamRoster : TfrmTeamRoster;
i,ct,mct,ml,mlt : integer;
begin
  mlt := 0;
  frmTeamRoster := TfrmTeamRoster.Create(Application);
  if FList.count >0 then
    begin
     ml:=0;
     str := piece(FList[0],';',2);
     ct := StrToInt(piece(piece(FList[0],'^',2),';',1));
     if ct > 0 then

     NewRow := True;
     mct := 0;
     for i :=1 to ct do
       begin
            Component0 := frmTeamRoster.FindComponent('lbx' + piece(str,'|',i));
            if Component0 = nil then
            begin
            inc(mct);
            NewMemo :=  TORListbox.Create(frmTeamRoster);
            NewLabel := TLabel.Create(frmTeamRoster);
            NewMemo.Top := 30;
            if (mct=1) or (mct > 4) then
            begin
              mct := 1;
              if (mct = 1)and (i > 1) then NewMemo.Top := LMemo.Top + NewMemo.Height + 20;

              NewRow := True;
              LMemo := NewMemo;
            end;

            NewMemo.Name := 'lbx' + piece(str,'|',i);
            NewMemo.Items.Clear;
            NewMemo.Width := ml;
            NewMemo.Left := mlt;
            mlt := mlt + ml;

            NewLabel.Name := 'lbl' + piece(str,'|',i);
            NewLabel.Caption := piece(str,'|',i);

            NewMemoSetup(NewMemo, NewLabel);
            if ListCtrls = nil then ListCtrls := TStringList.create;

            ListCtrls.Add(NewLabel.Name);
            ListCtrls.Add(NewMemo.Name);

      end;
     end;
     for i :=1 to FList.count-1 do
         begin
            Component := frmTeamRoster.FindComponent('lbx' + piece(FList[i],'^',1));
            if Component <> nil then (Component as TORListbox).Items.Add(piece(FList[i],'^',2) + '  ' +piece(FList[i],'^',4));
         end;

     end;

end;

procedure TfrmTeamRoster.cboPListDblClick(Sender: TObject);
var
rList :TStrings;
I : integer;
filename :String;
NewItem: TListItem;
NewColumn: TListColumn;
filePath,tf : String;
begin
rList := TStringList.Create;
rList.Clear;
ListView1.Items.BeginUpdate;
ListView1.Items.Clear;

if cboPList.itemindex > -1 then
begin
case (obj as TButton).tag of
    0 : tCallV(rList,'CRHD GET TEAM PHONE NUMBERS',[cboPList.items[cboPList.itemindex]]);
    1 : tCallV(rList,'CRHD USER PHONE INFO',[cboPList.items[cboPList.itemindex]]);
    2 : tCallV(rList, 'CRHD SPECIALTY INFO', [cboPList.items[cboPList.itemindex]]);
    3 : tCallV(rList, 'CRHD SERVICE INFO', [cboPList.items[cboPList.itemindex]]);
    4 : tCallV(rList,'CRHD HOT TEAM PHONE INFO', [cboPList.items[cboPList.itemindex]]);
 end;

  if frmListSelect.UserPar.FILE_Location <> '' then filePath := frmListSelect.UserPar.FILE_Location;
  filename := piece(cboPList.items[cboPList.itemindex],'^',2) + '.Txt';

  if filePath <> '' then
  begin
   tf := copy(filePath, Length(filePath),1 );
   if not (tf = '\') then filePath := filePath + '\';
   tf := filePath + filename;
   end;

  if Not FileExists(tf) then
   begin
    tf := GetCurrentDir + '\' + filename;
    if FileExists(tf) then filename := tf
    else filename := '';
   end
  else filename := tf;

  if fileName <> '' then
     begin
       if (Not PnlTmNotes.Visible) then PnlTmNotes.Visible := True;
       mmTmNotes.Lines.Clear;
       mmTmNotes.Hint:='File Last Edit: ' + GetFileAge(filename);
       mmTmNotes.Lines.LoadFromFile(filename);
       mmTmNotes.ReadOnly := True;
       FileOpened := filename;
     end
     else
     PnlTmNotes.Visible := False;

     if Not pnlBottom.Visible then pnlBottom.Visible := True;

      ListView1.Columns.Clear;
      if rList.count > 0 then
      begin
       AddColumnsToListView(FieldNames, ListView1);
       for I :=0 to rList.count -1 do
         AddListviewItem(rList[I], FieldNames, ListView1);
       end
       else
       begin
         NewColumn:= ListView1.Columns.Add;
         NewItem := ListView1.Items.Add;
         NewItem.Caption := 'No data found for ' + piece(cboPList.items[cboPList.itemindex],'^',2);
         NewColumn.Width := ListView1.Width;
       end;
       ListView1.Items.EndUpdate;
     // cboPList.SetFocus;

   CanEditTextDoc(cboPList.items[cboPList.itemindex]);
end;
end;

procedure TfrmTeamRoster.cboPListKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
if key = VK_RETURN then cboPListDblClick(cboPList);
end;

procedure TfrmTeamRoster.lbl_ServiceClick(Sender: TObject);
begin
obj := (Sender as TButton);
TurnToBlack;
cboPList.Visible := True;
cboPList.Items.Clear;
cboPList.Text := '';
ListService_Section(cboPList.Items);
end;

procedure TfrmTeamRoster.lbl_SpecialtyClick(Sender: TObject);
begin
obj := (Sender as TButton);
TurnToBlack;
cboPList.Visible := True;
cboPList.Items.Clear;
cboPList.Text := '';
ListSpecialtyAll(cboPList.Items);
end;

procedure TfrmTeamRoster.lbl_HOTeamClick(Sender: TObject);
begin
obj := (Sender as TButton);
TurnToBlack;
cboPList.Visible := True;
cboPList.Items.Clear;
cboPList.Text := '';
tCallV(cboPList.Items,'CRHD HOT TEAM LIST', [nil]);
end;

procedure TfrmTeamRoster.AddListViewItem(const aValue: String;
  FieldNames: array of Shortstring; aLV: TListView);
var
  NewItem: TListItem;
  i      : integer;
begin
   NewItem := aLV.Items.Add;

   NewItem.Caption :=piece(aValue,'^',2);

  for i := 3 to High(FieldNames)+1 do
         NewItem.subItems.Add(piece(aValue,'^',i));
end;

procedure TfrmTeamRoster.btnHOTeamKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
if Key = VK_TAB then lbl_HOTeamClick(btnHOTeam);
if Key = VK_RETURN then cboPList.SetFocus;
end;

procedure TfrmTeamRoster.btnServiceKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
if Key = VK_TAB then lbl_ServiceClick(btnService);
if Key = VK_RETURN then cboPList.SetFocus;
end;

procedure TfrmTeamRoster.btnSpecialtyKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
if Key = VK_TAB then lbl_SpecialtyClick(btnSpecialty);
if Key = VK_RETURN then cboPList.SetFocus;
end;

procedure TfrmTeamRoster.btnTeamKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
if Key = VK_TAB then lbl_TeamClick(btnTeam);
if Key = VK_RETURN then cboPList.SetFocus;

end;

procedure TfrmTeamRoster.btnUserKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
if Key = VK_TAB then lbl_UserClick(btnUser);
if Key = VK_RETURN then cboPList.SetFocus;
end;

procedure TfrmTeamRoster.Print1Click(Sender: TObject);
var
str : string;
begin
str := GetDefaultPrinterName ;
if str <> '' then
mmTmNotes.Print(piece(cboPList.items[cboPList.itemindex],'^',2) + '.Txt')
else
ShowMessage('No Default printer found');
end;

procedure TfrmTeamRoster.Save1Click(Sender: TObject);
begin
if pos('1',TeamMgr)>0 then
 if (FileOpened <> '') and (FileExists(FileOpened)) then
   mmTmNotes.Lines.SaveToFile(FileOpened)
 else
   ShowMessage('Only Team Managers can save data');
end;

procedure TfrmTeamRoster.FormActivate(Sender: TObject);
begin
 if cboPList.itemindex > -1 then CanEditTextDoc(cboPList.items[cboPList.itemindex]);
end;

procedure TfrmTeamRoster.CanEditTextDoc(TM: String);
var
Mi : TMenuItem;
begin
  TeamMgr := sCallV('CRHD HOT CAN EDIT',[TM , frmListSelect.DUZ]) ;
  if pos('1',TeamMgr)>0 then
  begin
   Mi := PopupMenu1.Items.Find('Save');
   if Mi <> nil then
    begin
     Mi.Enabled := True;
     mmTmNotes.ReadOnly := False;
    end;
  end;
 end;

procedure TfrmTeamRoster.TurnToBlack;
begin
btnTeam.Font.Style := [];
btnUser.Font.Style := [];
btnService.Font.Style := [];
btnSpecialty.Font.Style := [];
btnHOTeam.Font.Style := [];
(obj as TButton).Font.Style := [fsBold];
mmTmNotes.Lines.Clear;
pnlTmNotes.Visible := False;
end;

procedure TfrmTeamRoster.AddColumnsToListView(
  FieldNames: array of Shortstring; aLV: TListView);
var
  NewColumn: TListColumn;
  i : integer;
begin
 for i := 0 to High(FieldNames) do
 begin
  NewColumn := aLV.Columns.Add;
  NewColumn.caption := String(FieldNames[i]);
  NewColumn.AutoSize := True;
  if i=0 then  NewColumn.Width := 200
  else NewColumn.Width := 100;
 end;
end;

procedure TfrmTeamRoster.ListView1CustomDrawItem(Sender: TCustomListView;
  Item: TListItem; State: TCustomDrawState; var DefaultDraw: Boolean);
var
num : integer;
begin
with ListView1.Canvas.Brush do
  begin
     num :=Item.Index mod 2;
    case num of
      0 : Color := clBtnFace;
      1: Color := clWhite;
    end;
  end;
end;

procedure TfrmTeamRoster.FormCreate(Sender: TObject);
begin
Font := frmListSelect.Font;
btnTeam.Font.Size := Font.Size;
btnUser.Font.Size := Font.Size;
btnSpecialty.Font.Size := Font.Size;
btnHOTeam.Font.Size := Font.Size;
btnService.Font.Size := Font.Size;
end;

end.
